% Author: Diego & Yamand
% Date: 09/05/2014

% 0 == vacio, 1 == jug1 (Jugador), 2 == jug2 (Maquina)

%Tablero inicial
% tablero([0,0,0,0,0,0,0,0]    Cuadrado exterior
%        ,[0,0,0,0,0,0,0,0]   Cuadrado intermedio
%        ,[0,0,0,0,0,0,0,0]). Cuadrado interior

% Limpia la pantalla de comandos
:- module(molinero,
        [ molinero/0,
	  rivalSinFichas/1,
	  rivalBloqueado/2,
	  moves/3,
	  put/8,
	  opponent/1,
	  me/1,
	  phase/1,
	  fichasEnPuntosMedios/3,
	  unaFichaEnCadaNivel/2,
	  molinoFormado/3,
	  longitud/2
        ]).

:- use_module(algorithms,
        [ minimax/6            % The minimax algorithm
        ]).

		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
		
:- use_module(library(pce)).


	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		
% referente a la maquina
me(2).
opponent(1).

:- dynamic tablero/3,phase/1,bloqueado/1,lista1/1,lista2/1,segundaSeleccion/1.

limpia:-
        format('~c~s~c~s',[0x1b,"[H",0x1b,"[2J"]).

iesimo(X,0,[X|_]).
iesimo(X,N,[_|Xs]):- N1 is N-1, iesimo(X,N1,Xs).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Point - posicin (X, Y)    Line - longitud

% Crea la ventana de la interfaz del tablero
ventanaTablero:-

send(@grid,open),

% Lneas

	% Cuadrado exterior
send(@grid,display,new(@lineab,line(300,0)),point(62,62)),
send(@grid,display,new(@linebc,line(300,0)),point(362,62)),
send(@grid,display,new(@lineah,line(0,300)),point(87,62)),
send(@grid,display,new(@linehg,line(0,300)),point(87,362)),

send(@grid,display,new(@linegf,line(300,0)),point(62,662)),
send(@grid,display,new(@linefe,line(300,0)),point(362,662)),
send(@grid,display,new(@linecd,line(0,300)),point(687,62)),
send(@grid,display,new(@linede,line(0,300)),point(687,362)),

	% Cuadrado intermedio
send(@grid,display,new(@lineij,line(200,0)),point(162,162)),
send(@grid,display,new(@linejk,line(200,0)),point(362,162)),
send(@grid,display,new(@lineip,line(0,200)),point(187,162)),
send(@grid,display,new(@linepo,line(0,200)),point(187,362)),

send(@grid,display,new(@lineon,line(200,0)),point(162,562)),
send(@grid,display,new(@linenm,line(200,0)),point(362,562)),
send(@grid,display,new(@linekl,line(0,200)),point(587,162)),
send(@grid,display,new(@linelm,line(0,200)),point(587,362)),

	% Cuadrado interior
send(@grid,display,new(@lineqr,line(100,0)),point(262,262)),
send(@grid,display,new(@liners,line(100,0)),point(362,262)),
send(@grid,display,new(@lineqx,line(0,100)),point(287,262)),
send(@grid,display,new(@linexw,line(0,100)),point(287,362)),

send(@grid,display,new(@linewv,line(100,0)),point(262,462)),
send(@grid,display,new(@linevu,line(100,0)),point(362,462)),
send(@grid,display,new(@linest,line(0,100)),point(487,262)),
send(@grid,display,new(@linetu,line(0,100)),point(487,362)),

	% Lneas internivel

send(@grid,display,new(@linehp,line(100,0)),point(62,362)),
send(@grid,display,new(@linepx,line(100,0)),point(162,362)),
send(@grid,display,new(@linetl,line(100,0)),point(462,362)),
send(@grid,display,new(@lineld,line(100,0)),point(562,362)),

send(@grid,display,new(@linebj,line(0,100)),point(387,62)),
send(@grid,display,new(@linejr,line(0,100)),point(387,162)),
send(@grid,display,new(@linevn,line(0,100)),point(387,462)),
send(@grid,display,new(@linenf,line(0,100)),point(387,562)),


% Botones

send(@grid,display,new(@buttona,button('-',message(@prolog, botonPulsado,a))),point(50,50)),
send(@grid,display,new(@buttonb,button('-',message(@prolog, botonPulsado,b))),point(350,50)),
send(@grid,display,new(@buttonc,button('-',message(@prolog, botonPulsado,c))),point(650,50)),

send(@grid,display,new(@buttoni,button('-',message(@prolog, botonPulsado,i))),point(150,150)),
send(@grid,display,new(@buttonj,button('-',message(@prolog, botonPulsado,j))),point(350,150)),
send(@grid,display,new(@buttonk,button('-',message(@prolog, botonPulsado,k))),point(550,150)),

send(@grid,display,new(@buttonq,button('-',message(@prolog, botonPulsado,q))),point(250,250)),
send(@grid,display,new(@buttonr,button('-',message(@prolog, botonPulsado,r))),point(350,250)),
send(@grid,display,new(@buttons,button('-',message(@prolog, botonPulsado,s))),point(450,250)),

send(@grid,display,new(@buttonh,button('-',message(@prolog, botonPulsado,h))),point(50,350)),
send(@grid,display,new(@buttonp,button('-',message(@prolog, botonPulsado,p))),point(150,350)),
send(@grid,display,new(@buttonx,button('-',message(@prolog, botonPulsado,x))),point(250,350)),
send(@grid,display,new(@buttont,button('-',message(@prolog, botonPulsado,t))),point(450,350)),
send(@grid,display,new(@buttonl,button('-',message(@prolog, botonPulsado,l))),point(550,350)),
send(@grid,display,new(@buttond,button('-',message(@prolog, botonPulsado,d))),point(650,350)),
	
send(@grid,display,new(@buttonw,button('-',message(@prolog, botonPulsado,w))),point(250,450)),
send(@grid,display,new(@buttonv,button('-',message(@prolog, botonPulsado,v))),point(350,450)),
send(@grid,display,new(@buttonu,button('-',message(@prolog, botonPulsado,u))),point(450,450)),

send(@grid,display,new(@buttono,button('-',message(@prolog, botonPulsado,o))),point(150,550)),
send(@grid,display,new(@buttonn,button('-',message(@prolog, botonPulsado,n))),point(350,550)),
send(@grid,display,new(@buttonm,button('-',message(@prolog, botonPulsado,m))),point(550,550)),

send(@grid,display,new(@buttong,button('-',message(@prolog, botonPulsado,g))),point(50,650)),
send(@grid,display,new(@buttonf,button('-',message(@prolog, botonPulsado,f))),point(350,650)),
send(@grid,display,new(@buttone,button('-',message(@prolog, botonPulsado,e))),point(650,650)).


% cambiaBoton(+,+) Cambia el botn que representa Boton con el valor pasado en Valor
cambiaBoton(Boton,Valor):-
	X = Boton,
	(
	X = a, free(@buttona), send(@grid,display,new(@buttona,button(Valor,message(@prolog,botonPulsado,a))),  point(50,50));
	X = b, free(@buttonb), send(@grid,display,new(@buttonb,button(Valor,message(@prolog,botonPulsado,b))), point(350,50));
	X = c, free(@buttonc), send(@grid,display,new(@buttonc,button(Valor,message(@prolog,botonPulsado,c))), point(650,50));
	X = d, free(@buttond), send(@grid,display,new(@buttond,button(Valor,message(@prolog,botonPulsado,d))),point(650,350));
	X = e, free(@buttone), send(@grid,display,new(@buttone,button(Valor,message(@prolog,botonPulsado,e))),point(650,650));
	X = f, free(@buttonf), send(@grid,display,new(@buttonf,button(Valor,message(@prolog,botonPulsado,f))),point(350,650));
	X = g, free(@buttong), send(@grid,display,new(@buttong,button(Valor,message(@prolog,botonPulsado,g))), point(50,650));
	X = h, free(@buttonh), send(@grid,display,new(@buttonh,button(Valor,message(@prolog,botonPulsado,h))), point(50,350));
	X = i, free(@buttoni), send(@grid,display,new(@buttoni,button(Valor,message(@prolog,botonPulsado,i))),point(150,150));
	X = j, free(@buttonj), send(@grid,display,new(@buttonj,button(Valor,message(@prolog,botonPulsado,j))),point(350,150));
	X = k, free(@buttonk), send(@grid,display,new(@buttonk,button(Valor,message(@prolog,botonPulsado,k))),point(550,150));
	X = l, free(@buttonl), send(@grid,display,new(@buttonl,button(Valor,message(@prolog,botonPulsado,l))),point(550,350));
	X = m, free(@buttonm), send(@grid,display,new(@buttonm,button(Valor,message(@prolog,botonPulsado,m))),point(550,550));
	X = n, free(@buttonn), send(@grid,display,new(@buttonn,button(Valor,message(@prolog,botonPulsado,n))),point(350,550));
	X = o, free(@buttono), send(@grid,display,new(@buttono,button(Valor,message(@prolog,botonPulsado,o))),point(150,550));
	X = p, free(@buttonp), send(@grid,display,new(@buttonp,button(Valor,message(@prolog,botonPulsado,p))),point(150,350));
	X = q, free(@buttonq), send(@grid,display,new(@buttonq,button(Valor,message(@prolog,botonPulsado,q))),point(250,250));
	X = r, free(@buttonr), send(@grid,display,new(@buttonr,button(Valor,message(@prolog,botonPulsado,r))),point(350,250));
	X = s, free(@buttons), send(@grid,display,new(@buttons,button(Valor,message(@prolog,botonPulsado,s))),point(450,250));
	X = t, free(@buttont), send(@grid,display,new(@buttont,button(Valor,message(@prolog,botonPulsado,t))),point(450,350));
	X = u, free(@buttonu), send(@grid,display,new(@buttonu,button(Valor,message(@prolog,botonPulsado,u))),point(450,450));
	X = v, free(@buttonv), send(@grid,display,new(@buttonv,button(Valor,message(@prolog,botonPulsado,v))),point(350,450));
	X = w, free(@buttonw), send(@grid,display,new(@buttonw,button(Valor,message(@prolog,botonPulsado,w))),point(250,450));
	X = x, free(@buttonx), send(@grid,display,new(@buttonx,button(Valor,message(@prolog,botonPulsado,x))),point(250,350));
	false ) -> true ; false.

botonPulsado(Boton):-
	mueveJugadorInterfaz(Boton).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dibujaTablero:-
        limpia,
        tablero([S0,S1,S2,S3,S4,S5,S6,S7]
                ,[M0,M1,M2,M3,M4,M5,M6,M7]
                ,[I0,I1,I2,I3,I4,I5,I6,I7]),
        write(S0),write('     '),write(S1),write('     '),write(S2),                    write('   '),write(a),write('     '),write(b),write('     '),write(c),nl,
        write('  '),write(M0),write('   '),write(M1),write('   '),write(M2),write('  '),write('   '),write('  '),write(i),write('   '),write(j),write('   '),write(k),write('  '),nl,
        write('    '),write(I0),write(' '),write(I1),write(' '),write(I2),write('    '),write('   '),write('    '),write(q),write(' '),write(r),write(' '),write(s),write('    '),nl,

        write(S7),write(' '),write(M7),write(' '),write(I7),
        write('   '),
        write(I3),write(' '),write(M3),write(' '),write(S3),                            write('   '),write(h),write(' '),write(p),write(' '),write(x),
		                                                                                write('   '),
		                                                                                write(t),write(' '),write(l),write(' '),write(d),nl,

        write('    '),write(I6),write(' '),write(I5),write(' '),write(I4),write('    '),write('   '),write('    '),write(w),write(' '),write(v),write(' '),write(u),write('    '),nl,
        write('  '),write(M6),write('   '),write(M5),write('   '),write(M4),write('  '),write('   '),write('  '),write(o),write('   '),write(n),write('   '),write(m),write('  '),nl,
        write(S6),write('     '),write(S5),write('     '),write(S4),                    write('   '),write(g),write('     '),write(f),write('     '),write(e),nl,nl.

% quitarFichaTablero(+,+,+,-) Quitar la ficha del jugador Jug en la posicin Letra
quitarFichaTablero([S,M,I],Letra,Jug,[Sc,Mc,Ic]):-
        [S0,S1,S2,S3,S4,S5,S6,S7] = S,
        [M0,M1,M2,M3,M4,M5,M6,M7] = M,
        [I0,I1,I2,I3,I4,I5,I6,I7] = I,
        % switch de prolog
        X = Letra,
        (
        X = a, (S0 = 0 | Jug = S0), Sc =[0,S1,S2,S3,S4,S5,S6,S7],Mc = M, Ic = I;
        X = b, (S1 = 0 | Jug = S1), Sc =[S0,0,S2,S3,S4,S5,S6,S7],Mc = M, Ic = I;
        X = c, (S2 = 0 | Jug = S2), Sc =[S0,S1,0,S3,S4,S5,S6,S7],Mc = M, Ic = I;
        X = d, (S3 = 0 | Jug = S3), Sc =[S0,S1,S2,0,S4,S5,S6,S7],Mc = M, Ic = I;
        X = e, (S4 = 0 | Jug = S4), Sc =[S0,S1,S2,S3,0,S5,S6,S7],Mc = M, Ic = I;
        X = f, (S5 = 0 | Jug = S5), Sc =[S0,S1,S2,S3,S4,0,S6,S7],Mc = M, Ic = I;
        X = g, (S6 = 0 | Jug = S6), Sc =[S0,S1,S2,S3,S4,S5,0,S7],Mc = M, Ic = I;
        X = h, (S7 = 0 | Jug = S7), Sc =[S0,S1,S2,S3,S4,S5,S6,0],Mc = M, Ic = I;
        X = i, (M0 = 0 | Jug = M0), Mc =[0,M1,M2,M3,M4,M5,M6,M7],Sc = S, Ic = I;
        X = j, (M1 = 0 | Jug = M1), Mc =[M0,0,M2,M3,M4,M5,M6,M7],Sc = S, Ic = I;
        X = k, (M2 = 0 | Jug = M2), Mc =[M0,M1,0,M3,M4,M5,M6,M7],Sc = S, Ic = I;
        X = l, (M3 = 0 | Jug = M3), Mc =[M0,M1,M2,0,M4,M5,M6,M7],Sc = S, Ic = I;
        X = m, (M4 = 0 | Jug = M4), Mc =[M0,M1,M2,M3,0,M5,M6,M7],Sc = S, Ic = I;
        X = n, (M5 = 0 | Jug = M5), Mc =[M0,M1,M2,M3,M4,0,M6,M7],Sc = S, Ic = I;
        X = o, (M6 = 0 | Jug = M6), Mc =[M0,M1,M2,M3,M4,M5,0,M7],Sc = S, Ic = I;
        X = p, (M7 = 0 | Jug = M7), Mc =[M0,M1,M2,M3,M4,M5,M6,0],Sc = S, Ic = I;
        X = q, (I0 = 0 | Jug = I0), Ic =[0,I1,I2,I3,I4,I5,I6,I7],Sc = S, Mc = M;
        X = r, (I1 = 0 | Jug = I1), Ic =[I0,0,I2,I3,I4,I5,I6,I7],Sc = S, Mc = M;
        X = s, (I2 = 0 | Jug = I2), Ic =[I0,I1,0,I3,I4,I5,I6,I7],Sc = S, Mc = M;
        X = t, (I3 = 0 | Jug = I3), Ic =[I0,I1,I2,0,I4,I5,I6,I7],Sc = S, Mc = M;
        X = u, (I4 = 0 | Jug = I4), Ic =[I0,I1,I2,I3,0,I5,I6,I7],Sc = S, Mc = M;
        X = v, (I5 = 0 | Jug = I5), Ic =[I0,I1,I2,I3,I4,0,I6,I7],Sc = S, Mc = M;
        X = w, (I6 = 0 | Jug = I6), Ic =[I0,I1,I2,I3,I4,I5,0,I7],Sc = S, Mc = M;
        X = x, (I7 = 0 | Jug = I7), Ic =[I0,I1,I2,I3,I4,I5,I6,0],Sc = S, Mc = M;
		false ) -> true ; false.

% colocaFicha(+,+,+,-) Coloca la ficha del jugador Jug en la posicion Letra
colocaFicha([S,M,I],Letra,Jug,[Sc,Mc,Ic]):-

        [S0,S1,S2,S3,S4,S5,S6,S7] = S,
        [M0,M1,M2,M3,M4,M5,M6,M7] = M,
        [I0,I1,I2,I3,I4,I5,I6,I7] = I,
        % switch de prolog
        X = Letra,
        (
        X = a, S0 = 0, Sc =[Jug,S1,S2,S3,S4,S5,S6,S7],Mc = M, Ic = I;
        X = b, S1 = 0, Sc =[S0,Jug,S2,S3,S4,S5,S6,S7],Mc = M, Ic = I;
        X = c, S2 = 0, Sc =[S0,S1,Jug,S3,S4,S5,S6,S7],Mc = M, Ic = I;
        X = d, S3 = 0, Sc =[S0,S1,S2,Jug,S4,S5,S6,S7],Mc = M, Ic = I;
        X = e, S4 = 0, Sc =[S0,S1,S2,S3,Jug,S5,S6,S7],Mc = M, Ic = I;
        X = f, S5 = 0, Sc =[S0,S1,S2,S3,S4,Jug,S6,S7],Mc = M, Ic = I;
        X = g, S6 = 0, Sc =[S0,S1,S2,S3,S4,S5,Jug,S7],Mc = M, Ic = I;
        X = h, S7 = 0, Sc =[S0,S1,S2,S3,S4,S5,S6,Jug],Mc = M, Ic = I;
        X = i, M0 = 0, Mc =[Jug,M1,M2,M3,M4,M5,M6,M7],Sc = S, Ic = I;
        X = j, M1 = 0, Mc =[M0,Jug,M2,M3,M4,M5,M6,M7],Sc = S, Ic = I;
        X = k, M2 = 0, Mc =[M0,M1,Jug,M3,M4,M5,M6,M7],Sc = S, Ic = I;
        X = l, M3 = 0, Mc =[M0,M1,M2,Jug,M4,M5,M6,M7],Sc = S, Ic = I;
        X = m, M4 = 0, Mc =[M0,M1,M2,M3,Jug,M5,M6,M7],Sc = S, Ic = I;
        X = n, M5 = 0, Mc =[M0,M1,M2,M3,M4,Jug,M6,M7],Sc = S, Ic = I;
        X = o, M6 = 0, Mc =[M0,M1,M2,M3,M4,M5,Jug,M7],Sc = S, Ic = I;
        X = p, M7 = 0, Mc =[M0,M1,M2,M3,M4,M5,M6,Jug],Sc = S, Ic = I;
        X = q, I0 = 0, Ic =[Jug,I1,I2,I3,I4,I5,I6,I7],Sc = S, Mc = M;
        X = r, I1 = 0, Ic =[I0,Jug,I2,I3,I4,I5,I6,I7],Sc = S, Mc = M;
        X = s, I2 = 0, Ic =[I0,I1,Jug,I3,I4,I5,I6,I7],Sc = S, Mc = M;
        X = t, I3 = 0, Ic =[I0,I1,I2,Jug,I4,I5,I6,I7],Sc = S, Mc = M;
        X = u, I4 = 0, Ic =[I0,I1,I2,I3,Jug,I5,I6,I7],Sc = S, Mc = M;
        X = v, I5 = 0, Ic =[I0,I1,I2,I3,I4,Jug,I6,I7],Sc = S, Mc = M;
        X = w, I6 = 0, Ic =[I0,I1,I2,I3,I4,I5,Jug,I7],Sc = S, Mc = M;
        X = x, I7 = 0, Ic =[I0,I1,I2,I3,I4,I5,I6,Jug],Sc = S, Mc = M;
		false ) -> true ; false.

% Acierta en caso de que la letra sea del tipo de la ficha (vale para
% los 3 valores posibles de ficha: 0, 1 ,2)
% tipoFicha(+,+,+)
tipoFicha([S,M,I],Letra,Ficha):-
	%tablero(S,M,I),
        [S0,S1,S2,S3,S4,S5,S6,S7] = S,
        [M0,M1,M2,M3,M4,M5,M6,M7] = M,
        [I0,I1,I2,I3,I4,I5,I6,I7] = I,
        % switch de prolog
        X = Letra,
        (
        X = a, Ficha = S0;
        X = b, Ficha = S1;
        X = c, Ficha = S2;
        X = d, Ficha = S3;
        X = e, Ficha = S4;
        X = f, Ficha = S5;
        X = g, Ficha = S6;
        X = h, Ficha = S7;
        X = i, Ficha = M0;
        X = j, Ficha = M1;
        X = k, Ficha = M2;
        X = l, Ficha = M3;
        X = m, Ficha = M4;
        X = n, Ficha = M5;
        X = o, Ficha = M6;
        X = p, Ficha = M7;
        X = q, Ficha = I0;
        X = r, Ficha = I1;
        X = s, Ficha = I2;
        X = t, Ficha = I3;
        X = u, Ficha = I4;
        X = v, Ficha = I5;
        X = w, Ficha = I6;
        X = x, Ficha = I7;
		false ) -> true ; false.

% concatena(+Letra,+Lista,-NuevaLista)
concatena(Letra,[],[Letra]).
concatena(Letra,Xs,[Letra|Xs]).

% quita(+Letra,+Lista,-NuevaLista)
quita(_,[],[]).
quita(Letra,[Letra|Xs],Xs):-!.
quita(Letra,[X|Xs],[X|Zx]):- quita(Letra,Xs,Zx).

% longitud(+Lista,-Longitud)
longitud([],0).
longitud([_X|Xs],NN):- longitud(Xs,N),NN is N+1.

% bucleMolino(+) Quita la ficha pasada por parametro tanto en el tablero como en la interfaz.
bucleMolino(Quitar):-
		tablero(S,M,I),
		(tipoFicha([S,M,I],Quitar,2),not(molinoFormado([S,M,I],Quitar,2)) ->
			quitarFichaTablero([S,M,I],Quitar,2,[Sr,Mr,Ir]),
			retract(tablero(_S,_M,_I)),assertz(tablero(Sr,Mr,Ir)),
			cambiaBoton(Quitar,'-'),
			lista2(X), quita(Quitar,X,Lista),
			longitud(Lista,Long),
			retract(lista2(_X)),
			assertz(lista2(Lista)),
			retractall(molino(_)),
			assertz(molino(false)),			
			(phase(1) ->   % estamos en la fase de mover piezas
				 ( Long < 3 ->
					haTerminado %assertz(juegoAcabado(true))
				 ;
					turnoMaquinaInterfaz
				 )
			 ;
				turnoMaquinaInterfaz
			 )
		;
			dibujaTablero,
			write('No puedes quitar la ficha '),write(Quitar),nl
		).
		
% colocaFichaJugador(+) Coloca la ficha del usuario en la posicion especificada por parametro.
colocaFichaJugador(Letra1):-
	tablero(S,M,I),
	(colocaFicha([S,M,I],Letra1,1,[Sr,Mr,Ir]) ->	   
	   retract(tablero(_S,_M,_I)),
	   assertz(tablero(Sr,Mr,Ir)),
	   cambiaBoton(Letra1,'O'),
	   lista1(X),
	   concatena(Letra1,X,Fichas1),
	   retract(lista1(_X)),
	   assertz(lista1(Fichas1)),	   
		(molinoFormado([Sr,Mr,Ir],Letra1,1) ->
		 assertz(molino(true)),    %hemos hecho un molino, hay que quitar una ficha rival
		 write('Molino! Que ficha quieres quitar?'),nl,
		 new(@molinoJug, dialog('Molino Jugador')),
			% Crea un boton para cerrar el dialogo
			new(@boton, button('Molino! Que ficha quieres quitar?',and(message(@molinoJug, destroy),message(@molinoJug, free),message(@molinoJug, free),message(@boton, free)))),
			send(@molinoJug, append(@boton)),
			send(@molinoJug, open)
		;
		 turnoMaquinaInterfaz		% no hemos hecho molino, continua el juego %% Interfaz
		) 
	   ;
	   dibujaTablero,
	   write('Posicin no vlida'),nl
	).

% Pone la ficha del jugador 'Jug' de la posicin 'Letra1' en la posicin 'Letra2'
% moverFicha(+,+,+,+)
moverFicha([S,M,I],Letra1,Letra2,Jug):-
	quitarFichaTablero([S,M,I],Letra1,Jug,[Sf,Mf,If]),
	colocaFicha([Sf,Mf,If],Letra2,Jug,[Sf2,Mf2,If2]),
	cambiaBoton(Letra1,'-'),cambiaBoton(Letra2,'O'),
	(Jug is 1 -> lista1(X) ; lista2(X)),
	quita(Letra1,X,Fichas1), concatena(Letra2,Fichas1,Fichas2),
	(Jug is 1 ->
		retract(lista1(_X)),
		assertz(lista1(Fichas2))
	;		
		retract(lista2(_X)),
		assertz(lista2(Fichas2))
	),
	assertz(tablero(Sf2,Mf2,If2)), retract(tablero(S,M,I)).

% mueveFichaJugador(+,+) Hace las comprobaciones necesarias al mover la ficha del jugador.
mueveFichaJugador(Letra1,Letra2):-
	tablero(S,M,I),
   (Letra2 \= Letra1,tipoFicha([S,M,I],Letra1,1),tipoFicha([S,M,I],Letra2,0),
   sonAdyacentes(Letra1,Letra2) ->
		moverFicha([S,M,I],Letra1,Letra2,1),
		tablero(Sf2,Mf2,If2),
		(molinoFormado([Sf2,Mf2,If2],Letra2,1) ->
		 assertz(molino(true)),    %hemos hecho un molino, hay que quitar una ficha rival
		 write('Molino! Que ficha quieres quitar?'),nl,
		 new(@molinoJug, dialog('Molino Jugador')),
			% Crea un boton para cerrar el dialogo
			new(@boton, button('Molino! Que ficha quieres quitar?',and(message(@molinoJug, destroy),message(@molinoJug, free),message(@molinoJug, free),message(@boton, free)))),
			send(@molinoJug, append(@boton)),
			send(@molinoJug, open)
		 ;
		 turnoMaquinaInterfaz		% no hemos hecho molino, continua el juego
		)
	;
		dibujaTablero,
		write('Movimiento no valido'),nl
	).

% mueveJugador(+,+) Determina si el jugador est moviendo segn la primera o la segunda fase del juego.
mueveJugador(Letra1, Letra2):-
	tablero(S,M,I),
	(phase(1),jugadorBloqueado([S,M,I],1) -> assertz(bloqueado(1)), haTerminado %assertz(juegoAcabado(true))
	;
		segundaSeleccion(X),
		( X = 0   ->
			colocaFichaJugador(Letra1)
		;			
			retract(segundaSeleccion(_)),
			assertz(segundaSeleccion(0)),
			mueveFichaJugador(Letra1,Letra2)
		)
	).

% unSoloAdyacente(L+,Acu?,Letra-).
unSoloAdyacente([],0,_):- false.
unSoloAdyacente([],1,_).
unSoloAdyacente([X|Xs],Acu,Letra):-
		(sonAdyacentes(X,Letra) ->
			(Acu is 1 ->
				!,false
			;
				!,unSoloAdyacente(Xs,1,Letra)
			)
		;
			unSoloAdyacente(Xs,Acu,Letra)
		).

% buscaPeligrosas(+Tablero,+Lista,-ListaDev) Busca todas las fichas con solo una ficha adyacente y que no estn formando un molino
buscaPeligrosas([S,M,F],X,Peligrosas):-		
		findall(Pos,
		(member(Pos,X),unSoloAdyacente(X,0,Pos),not(molinoFormado([S,M,F],Pos,1))),
		Peligrosas
		).

%quitarFicha(+,+,+) Quita una ficha del tablero
quitarFicha([Sf,Mf,If],Ficha,Jug):-
			quitarFichaTablero([Sf,Mf,If],Ficha,Jug,[Sr,Mr,Ir]),
				 retract(tablero(_S,_M,_I)),assertz(tablero(Sr,Mr,Ir)),
				 (Jug is 1 -> lista1(X) ; lista2(X)),
				 quita(Ficha,X,NuevaLista),
				 longitud(NuevaLista,Long),
				 (Jug is 1 ->
						retract(lista1(_X)),
						assertz(lista1(NuevaLista))					
					;
						retract(lista2(_X)),
						assertz(lista2(NuevaLista))						
					),
				(phase(1) ->   % estamos en la fase de mover piezas
					( Long < 3 ->
						haTerminado %assertz(juegoAcabado(true))
					;
						true)
				;
					true
				).

% compruebaMaqMolino(+,+,-,-) comprueba si la maquina se ha hecho un molino y resuelve mediante buscaPeligrosas.
compruebaMaqMolino([Sf,Mf,If],Pos,Molino,Ficha):-
			lista1(X),
			(molinoFormado([Sf,Mf,If],Pos,2) ->
			 Molino is 1,
			 % buscar las fichas del jugador mas peligrosas			 
			 buscaPeligrosas([Sf,Mf,If],X,Lista),
			 longitud(Lista,Long),
			 (Long > 0 ->
				Sel is random(Long), iesimo(Ficha,Sel,Lista),%se selecciona una al azar entre las peligrosas
				quitarFicha([Sf,Mf,If],Ficha,1),
				cambiaBoton(Ficha,'-')			%% Interfaz
			 ;
				% de las fichas puestas solo podemos seleccionar las que no estn formando un molino
				findall(Pos1, (member(Pos1,X),not(molinoFormado([Sf,Mf,If],Pos1,1))),X1),
				longitud(X1,L),
				( L = 0 -> true % esto quiere decir que las fichas restantes estan formando un molino
				;
				Sel is random(L), iesimo(Ficha,Sel,X1),%se selecciona una al azar entre las que haya
				quitarFicha([Sf,Mf,If],Ficha,1),
				cambiaBoton(Ficha,'-')			%%  Interfaz
			    )
			)
			 ;

			 Molino is 0
			 % no hemos hecho molino, continua el juego
			 ).

% mueveMaquina(+,+) Realiza el algoritmo minimax para determinar la jugada de la maquina.
mueveMaquina(NumPiezas,Prof):-
	retract(molino(_)),
    assertz(molino(false)),
	tablero(S,M,I),
	(phase(1),jugadorBloqueado([S,M,I],2) -> assertz(bloqueado(2)), haTerminado %assertz(juegoAcabado(true))
	;
		(NumPiezas > 0 ->
			( % Poner piezas en la mejor posicin
				tablero(S,M,I),
				% Tablero, Jugador(mquina), Mejor Movimiento,
				lista1(X1), lista2(X2),
				minimax([S,M,I],(Pos1,_Pos2),_MejorValor,Prof,X1,X2),
				colocaFicha([S,M,I],Pos1,2,[Sf,Mf,If]),
				cambiaBoton(Pos1,'X'),							%%% Interfaz
				lista2(X),concatena(Pos1,X,Fichas1),
				retract(lista2(_X)),assertz(lista2(Fichas1)),
				retract(tablero(_S,_M,_I)),assertz(tablero(Sf,Mf,If)),
				% Si la mquina hace un molino buscar las fichas ms peligrosas del jugador
				compruebaMaqMolino([Sf,Mf,If],Pos1,Molino,Ficha)
			)
			;
			( % Mover una pieza a la mejor posicin
				tablero(S,M,I),
				% Tablero, Jugador(mquina), Mejor Movimiento,
				lista1(X1), lista2(X2),
				minimax([S,M,I],(Pos1,Pos2),_MejorValor,Prof,X1,X2),
				moverFicha([S,M,I],Pos1,Pos2,2),tablero(Sf2,Mf2,If2),
				cambiaBoton(Pos1,'-'),cambiaBoton(Pos2,'X'),			%%% Interfaz
				compruebaMaqMolino([Sf2,Mf2,If2],Pos2,Molino,Ficha)
			)
		),
		dibujaTablero,
		(Molino == 1 ->
			write('La maquina ha hecho molino! Te ha quitado la ficha '),write(Ficha),nl,
			new(@molinoMaq, dialog('Molino Mquina')),
			string_concat('La maquina ha hecho molino! Te ha quitado la ficha: ',Ficha,Text),
			% Crea un boton para cerrar el dialogo
			new(@boton, button(Text,and(message(@molinoMaq, destroy),message(@molinoMaq, free),message(@molinoMaq, free),message(@boton, free)))),
			send(@molinoMaq, append(@boton)),
			send(@molinoMaq, open)
		;
			true
		)
	).
	% write('Te toca.'),
	% read(Letra1).

% escribePiezasRestantes(+) Escribe por consola el nmero de piezas restantes
escribePiezasRestantes(NumPiezas):-
	(NumPiezas > 0 ->
		write(NumPiezas),
		write(' piezas restantes'), nl
	;
		true
	).

% haTerminado Libera toda la memoria de la base de conocimeinto
haTerminado:-
	free(@grid),
	retractall(juegoAcabado(_)),
	retractall(tablero(_S,_M,_I)),
	retractall(fichas(_)),	retractall(molino(_)),
	retractall(dif(_)),	retractall(mover(_)),
	retractall(segundaSeleccion(_)),
	lista1(L1),lista2(L2),
	longitud(L1,N1),longitud(L2,N2),
	(phase(1) ->
		( N1 < 3 -> write('Has perdido :('),nl ; true),
		( N2 < 3 -> write('Has ganado :)'),nl ; true),
		(bloqueado(1) -> write('Jugador bloqueado, has perdido :('),nl ; true),
		(bloqueado(2) -> write('Maquina bloqueada, has ganado :)'),nl ; true)
	;
		true),
	retractall(phase(_)),
	retractall(bloqueado(_)),retractall(lista1(_)),retractall(lista2(_))
	.

% mueveJugadorInterfaz(+) Determina que tipo de movimiento tiene que hacer el jugador con la interfaz
mueveJugadorInterfaz(Sel):-
	fichas(NumPiezas),
	(molino(true) ->
		bucleMolino(Sel)
	;
		
		(NumPiezas > 0 ->	
			mueveJugador(Sel,Sel)
		;
			( phase(0) -> retract(phase(_)), assertz(phase(1)) ; true),
			segundaSeleccion(Sel2),
			( Sel2 = 0 -> 
				retract(segundaSeleccion(_)),assertz(segundaSeleccion(Sel))
			;
				mueveJugador(Sel2,Sel)
			)
		)
	).

% turnoMaquinaInterfaz Determina si le toca mover a la maquina
turnoMaquinaInterfaz:-
	fichas(NumPiezas),
	(not(juegoAcabado(true)) ->
		dif(Dif), mueveMaquina(NumPiezas,Dif)
		;
		haTerminado
	),
	((NumPiezas>0) -> 
		PiezasRestantes is NumPiezas -1,	
		retract(fichas(NumPiezas)), assert(fichas(PiezasRestantes)),
		((PiezasRestantes = 0) ->
				new(@mueve, dialog('No quedan ms fichas')),
				% Crea un boton para cerrar el dialogo
				new(@botonMueve, button('Te toca mover las fichas.',and(message(@mueve, destroy),message(@mueve, free),message(@mueve, free),message(@botonMueve, free)))),
				send(@mueve, append(@botonMueve)),
				send(@mueve, open)
		;
			true
		)
	;
		true
	)
	.

% bucleJuego(+) Prepara el juego para empezar a jugar
bucleJuego(Dif):-
	fichas(NumPiezas),
	assert(molino(false)),
	assert(dif(Dif)),
	assert(mover(false)),
	escribePiezasRestantes(NumPiezas).

% dificultad(+) Se encarga de guardar la dificultad del juego
dificultad(Dif):-
		limpia, write('Selecciona la dificultad (facil,dificil):'),nl,
		read(Resp),
		(Resp = facil -> 
			Dif = 2
		;
			(Resp = dificil -> 
				Dif = 4
			;
				dificultad(Dif)
			)
		).

% molinero Llamada inicial a la aplicacion.
molinero:-
        % Inicializacin del juego
	assertz(tablero([0,0,0,0,0,0,0,0]    %Cuadrado exterior
        ,[0,0,0,0,0,0,0,0]            % Cuadrado intermedio
        ,[0,0,0,0,0,0,0,0])),		  % Cuadrado interior
	assertz(juegoAcabado(false)),
	assertz(segundaSeleccion(0)),
	assertz(fichas(9)), assertz(lista1([])), assertz(lista2([])),
	assertz(phase(0)),
	dificultad(Dif),
	dibujaTablero,
		%%%%%%%%%%%%%%%%%%%%%%%%%
	 new(@grid,window('Pantalla',size(800,800))),
	 ventanaTablero,
	%%%%%%%%%%%%%%%%%%%%%%%%%
    bucleJuego(Dif).

movF(a). movF(b). movF(c). movF(d). movF(e). movF(f). movF(g). movF(h).
movF(i). movF(j). movF(k). movF(l). movF(m). movF(n). movF(o). movF(p).
movF(q). movF(r). movF(s). movF(t). movF(u). movF(v). movF(w). movF(x).

% devuelve todos los movimientos posibles como tuplas Pos1 Pos2 donde
% el movimiento va de Pos1 -> Pos2, en caso de ser el mismo es porque introducimos
% una nueva ficha en la funcin put
% moves(+,-,+)
moves(Tablero,Movimientos,MinOMax):-
	fichas(NumFichas),
	(NumFichas > 0 ->
	findall((Pos,Pos),
		(movF(Pos),tipoFicha(Tablero,Pos,0)),  % la posicion en la que se puede poner esta vacia.
	       Movimientos)
	;
	(MinOMax = min ->  % movimiento del rival, el jugador Jug = 1
			findall((Pos1,Pos2),
			  (movF(Pos1),tipoFicha(Tablero,Pos1,1),
			  movF(Pos2),tipoFicha(Tablero,Pos2,0),
			  sonAdyacentes(Pos1,Pos2)),  % la posicion en la que se puede poner esta vacia.
			   Movimientos)
			; % movimiento nuestro
			findall((Pos1,Pos2),
			  (movF(Pos1),tipoFicha(Tablero,Pos1,2),
			  movF(Pos2),tipoFicha(Tablero,Pos2,0),
			  sonAdyacentes(Pos1,Pos2)),  % la posicion en la que se puede poner esta vacia.
			   Movimientos)
		)
	)
	.

% devuelve en NuevoTablero el movimiento de posicionar la ficha en Pos1 en la
% posicin pos2, X1 es la lista de las fichas del jugador 1 y X2 del jugador 2
% put(+,+,+,+,+,-,-,-)
put(Tablero,(Pos1,Pos2),Ficha,X1,X2,NuevoTablero, NX1, NX2):-
	quitarFichaTablero(Tablero,Pos1,Ficha,TableroAux), % quitar ficha devuelve ture aunque la ficha quitada sea 0
	colocaFicha(TableroAux,Pos2,Ficha,TableroInter),
	(Ficha is 1 -> 
		quita(Pos1,X1,X1Aux), concatena(Pos2,X1Aux,NX1),
		(molinoFormado(TableroInter,Pos2,Ficha) ->
			buscaPeligrosas(TableroInter,X2,XList),longitud(XList,Long),
			(Long > 0 ->
				Sel is random(Long), %se selecciona una al azar entre las peligrosas
				iesimo(Pos,Sel,X2),quitarFichaTablero(TableroInter,Pos,2,NuevoTablero), quita(Pos,X2,NX2)
			;
				findall(Pos3, (member(Pos3,X2),not(molinoFormado(TableroInter,Pos3,2))),List),
				longitud(List,L),
				( L = 0 -> 
					NX2 = X2 % esto quiere decir que las fichas restantes estan formando un molino
				;
					Sel is random(L), iesimo(Pos,Sel,List),%se selecciona una al azar entre las que haya
					quitarFichaTablero(TableroInter,Pos,2,NuevoTablero), quita(Pos,X2,NX2)
				)
			)
		;
			NX2 = X2,
			NuevoTablero = TableroInter			
		)
	; %Ficha is 2
		quita(Pos1,X2,X2Aux), concatena(Pos2,X2Aux,NX2),
		(molinoFormado(TableroInter,Pos2,Ficha) ->
			buscaPeligrosas(TableroInter,X1,XList),longitud(XList,Long),
			(Long > 0 ->
				Sel is random(Long), %se selecciona una al azar entre las peligrosas
				iesimo(Pos,Sel,X1),quitarFichaTablero(TableroInter,Pos,1,NuevoTablero), quita(Pos,X1,NX1)
			;
				findall(Pos3, (member(Pos3,X1),not(molinoFormado(TableroInter,Pos3,1))),List),
				longitud(List,L),
				( L = 0 -> 
					NX1 = X1 % esto quiere decir que las fichas restantes estan formando un molino
				;
					Sel is random(L), iesimo(Pos,Sel,List),%se selecciona una al azar entre las que haya
					quitarFichaTablero(TableroInter,Pos,1,NuevoTablero), quita(Pos,X1,NX1)
				)
			)
		;
			NX1 = X1,
			NuevoTablero = TableroInter			
		)
	)
	.
% Saca por el segundo parametro las posiciones adyacentes a la posicion pasada por e primer argumento
% adyacente(+,-)
adyacente(Pos1,Pos2):- % (+Pos1,-Pos2)
	X = Pos1,
	(
	X = a, Pos2 = [b,h];
	X = b, Pos2 = [a,c,j];
	X = c, Pos2 = [b,d];
	X = d, Pos2 = [c,e,l];
	X = e, Pos2 = [d,f];
	X = f, Pos2 = [e,g,n];
	X = g, Pos2 = [f,h];
	X = h, Pos2 = [a,g,p];
	X = i, Pos2 = [p,j];
	X = j, Pos2 = [b,i,k,r];
	X = k, Pos2 = [j,l];
	X = l, Pos2 = [d,k,m,t];
	X = m, Pos2 = [l,n];
	X = n, Pos2 = [f,m,o,v];
	X = o, Pos2 = [n,p];
	X = p, Pos2 = [h,i,o,x];
	X = q, Pos2 = [r,x];
	X = r, Pos2 = [q,s,j];
	X = s, Pos2 = [r,t];
	X = t, Pos2 = [l,s,u];
	X = u, Pos2 = [t,v];
	X = v, Pos2 = [n,u,w];
	X = w, Pos2 = [v,x];
	X = x, Pos2 = [p,q,w];
	false ) -> true ; false.

% sonAdyacentes(+,-) Devuelve una posicin adyacente al primer parametro
sonAdyacentes(Pos1,Pos2):- 
	adyacente(Pos1,Lista),
	member(Pos2,Lista).
	
% Estar bloqueada si las posiciones adyacentes estn ocupadas
% fichaBloqueada(+,+)
fichaBloqueada(Tablero,Pos1) :- 
	adyacente(Pos1,Lista),
	todasOcupadas(Tablero,Lista).

% Acierta si todas las fichas de la lista del segundo parametro estn ocupadas por fichas	
% todasOcupadas(+,+) 
todasOcupadas(_Tablero,[]).

todasOcupadas(Tablero,[X|Xs]):-
	(tipoFicha(Tablero,X,1) | tipoFicha(Tablero,X,2)),
	todasOcupadas(Tablero,Xs).

% bloqueadas(+,+) Acierta si las fichas pasadas por segundo parametro estan bloqueadas
bloqueadas(_Tablero, []).

bloqueadas(Tablero, [X|Xs]):-
	fichaBloqueada(Tablero,X),
	bloqueadas(Tablero,Xs).

% jugadorBloqueado(+,+) Acierta si el jugador pasado por parametro est bloqueado
jugadorBloqueado(Tablero,Jug):-
	(Jug = 1 ->
	 lista1(Lista)
	 ;
	 lista2(Lista)
	),
	longitud(Lista, Long),
	(Long > 0 ->
		bloqueadas(Tablero,Lista)
	;
		false
	).

% rival(+,-) Saca por el segundo parametro quien es el rival del primero
rival(Player,Rival):-
	(Player = 2 -> Rival = 1
		;
		Rival = 2
	).

% rivalBloqueado(+,+) Acierta si el rival esta bloqueado
rivalBloqueado(Board, Player):-
	rival(Player,Rival),
	jugadorBloqueado(Board,Rival).

% rivalSinFichas(+,+) Acierta si el rival no tiene fichas suficientes
rivalSinFichas( Player):-
	(phase(1) ->
		rival(Player,Rival),
		( Rival = 1 ->
			lista1(L1),longitud(L1,N1),
			N1 < 3
			;
			lista2(L2),
			longitud(L2,N2),
			N2 < 3
		)
	;
		false
	).

% molinoFormado(+,+,+) Acierta si se est haciendo un molino con la ficha Jug en la posicion Movida
molinoFormado(Board,Movida,Jug):-
	X = Movida,
	(
	X = a, ((tipoFicha(Board,b,Jug),tipoFicha(Board,c,Jug)) | (tipoFicha(Board,h,Jug),tipoFicha(Board,g,Jug)));
	X = b, ((tipoFicha(Board,a,Jug),tipoFicha(Board,c,Jug)) | (tipoFicha(Board,j,Jug),tipoFicha(Board,r,Jug)));
	X = c, ((tipoFicha(Board,a,Jug),tipoFicha(Board,b,Jug)) | (tipoFicha(Board,d,Jug),tipoFicha(Board,e,Jug)));
	X = d, ((tipoFicha(Board,c,Jug),tipoFicha(Board,e,Jug)) | (tipoFicha(Board,t,Jug),tipoFicha(Board,l,Jug)));
	X = e, ((tipoFicha(Board,c,Jug),tipoFicha(Board,d,Jug)) | (tipoFicha(Board,f,Jug),tipoFicha(Board,g,Jug)));
	X = f, ((tipoFicha(Board,g,Jug),tipoFicha(Board,e,Jug)) | (tipoFicha(Board,v,Jug),tipoFicha(Board,n,Jug)));
	X = g, ((tipoFicha(Board,f,Jug),tipoFicha(Board,e,Jug)) | (tipoFicha(Board,a,Jug),tipoFicha(Board,h,Jug)));
	X = h, ((tipoFicha(Board,a,Jug),tipoFicha(Board,g,Jug)) | (tipoFicha(Board,p,Jug),tipoFicha(Board,x,Jug)));
	X = i, ((tipoFicha(Board,j,Jug),tipoFicha(Board,k,Jug)) | (tipoFicha(Board,p,Jug),tipoFicha(Board,o,Jug)));
	X = j, ((tipoFicha(Board,b,Jug),tipoFicha(Board,r,Jug)) | (tipoFicha(Board,i,Jug),tipoFicha(Board,k,Jug)));
	X = k, ((tipoFicha(Board,i,Jug),tipoFicha(Board,j,Jug)) | (tipoFicha(Board,l,Jug),tipoFicha(Board,m,Jug)));
	X = l, ((tipoFicha(Board,k,Jug),tipoFicha(Board,m,Jug)) | (tipoFicha(Board,d,Jug),tipoFicha(Board,t,Jug)));
	X = m, ((tipoFicha(Board,k,Jug),tipoFicha(Board,l,Jug)) | (tipoFicha(Board,o,Jug),tipoFicha(Board,n,Jug)));
	X = n, ((tipoFicha(Board,o,Jug),tipoFicha(Board,m,Jug)) | (tipoFicha(Board,v,Jug),tipoFicha(Board,f,Jug)));
	X = o, ((tipoFicha(Board,i,Jug),tipoFicha(Board,p,Jug)) | (tipoFicha(Board,n,Jug),tipoFicha(Board,m,Jug)));
	X = p, ((tipoFicha(Board,i,Jug),tipoFicha(Board,o,Jug)) | (tipoFicha(Board,h,Jug),tipoFicha(Board,x,Jug)));
	X = q, ((tipoFicha(Board,r,Jug),tipoFicha(Board,s,Jug)) | (tipoFicha(Board,x,Jug),tipoFicha(Board,w,Jug)));
	X = r, ((tipoFicha(Board,q,Jug),tipoFicha(Board,s,Jug)) | (tipoFicha(Board,b,Jug),tipoFicha(Board,j,Jug)));
	X = s, ((tipoFicha(Board,q,Jug),tipoFicha(Board,r,Jug)) | (tipoFicha(Board,t,Jug),tipoFicha(Board,u,Jug)));
	X = t, ((tipoFicha(Board,s,Jug),tipoFicha(Board,u,Jug)) | (tipoFicha(Board,l,Jug),tipoFicha(Board,d,Jug)));
	X = u, ((tipoFicha(Board,s,Jug),tipoFicha(Board,t,Jug)) | (tipoFicha(Board,v,Jug),tipoFicha(Board,w,Jug)));
	X = v, ((tipoFicha(Board,u,Jug),tipoFicha(Board,w,Jug)) | (tipoFicha(Board,n,Jug),tipoFicha(Board,f,Jug)));
	X = w, ((tipoFicha(Board,v,Jug),tipoFicha(Board,u,Jug)) | (tipoFicha(Board,q,Jug),tipoFicha(Board,x,Jug)));
	X = x, ((tipoFicha(Board,q,Jug),tipoFicha(Board,w,Jug)) | (tipoFicha(Board,h,Jug),tipoFicha(Board,p,Jug)));
	false ) -> true ; false.

	
%% Mtodos para la heurstica

% encuentra(+,+,+) Acierta si encuentra una ficha del tipo Player en las posiciones de la lista
encuentra(Board,Player,[X|Xs]):-
(
	tipoFicha(Board,X,Player) -> 
		true
	;
	encuentra(Board,Player,Xs)
).

% fichaEnExterior(+,+) Acierta si hay una ficha en el cuadrado exterior
fichaEnExterior(Board,Player):-
	encuentra(Board,Player,[a,b,c,d,e,f,g,h]).

% fichaEnMedio(+,+) Acierta si hay una ficha en el cuadrado medio	
fichaEnMedio(Board,Player):-
	encuentra(Board,Player,[i,j,k,l,m,n,o,p]).
	
% fichaEnInterior(+,+) Acierta si hay una ficha en el cuadrado interior
fichaEnInterior(Board,Player):-
	encuentra(Board,Player,[q,r,s,t,u,v,w,x]).

% unaFichaEnCadaNivel(+,+) Acierta si hay una ficha en cada nivel del tipo Player
unaFichaEnCadaNivel(Board,Player):-
	fichaEnExterior(Board,Player),
	fichaEnMedio(Board,Player),
	fichaEnInterior(Board,Player).

% fichasEnPuntosMedios(+,+,-) Devuelve en el tercer parametro el numero de fichas en puntos medios
fichasEnPuntosMedios(Board,Player,N):-
	cuantasMias(Board,Player,[p,j,l,n],0,N).
	
% cuantasMias(+,+,+,-) Devuelve en el cuarto parametro cuantas fichas de tipo Player hay en la lista
cuantasMias(_Board,_Player,[],M,N):-
	N = M.
	
cuantasMias(Board,Player,[X|Xs],M,N):-
	(
	tipoFicha(Board,X,Player) -> 
		cuantasMias(Board,Player,Xs,M+1,N)
	;
		cuantasMias(Board,Player,Xs,M,N)
	).
